/**
 * This module implements an map of pointer states
 */
var USE_MAP = window.Map && window.Map.prototype.forEach;
var POINTERS_FN = function(){ return this.size; };
function PointerMap() {
  if (USE_MAP) {
    var m = new Map();
    m.pointers = POINTERS_FN;
    return m;
  } else {
    this.keys = [];
    this.values = [];
  }
}

PointerMap.prototype = {
  set: function(inId, inEvent) {
    var i = this.keys.indexOf(inId);
    if (i > -1) {
      this.values[i] = inEvent;
    } else {
      this.keys.push(inId);
      this.values.push(inEvent);
    }
  },
  has: function(inId) {
    return this.keys.indexOf(inId) > -1;
  },
  'delete': function(inId) {
    var i = this.keys.indexOf(inId);
    if (i > -1) {
      this.keys.splice(i, 1);
      this.values.splice(i, 1);
    }
  },
  get: function(inId) {
    var i = this.keys.indexOf(inId);
    return this.values[i];
  },
  clear: function() {
    this.keys.length = 0;
    this.values.length = 0;
  },
  // return value, key, map
  forEach: function(callback, thisArg) {
    this.values.forEach(function(v, i) {
      callback.call(thisArg, v, this.keys[i], this);
    }, this);
  },
  pointers: function() {
    return this.keys.length;
  }
};

export default PointerMap;
